#include "csapp.h"

static volatile int count;

void ctl_c(int sig) {
  sio_puts("c\n");
  count++;
}

int main() {
  int status;
  pid_t pid;

  sigset_t sigs;
  Sigemptyset(&sigs);
  Sigaddset(&sigs, SIGINT);
  Sigprocmask(SIG_BLOCK, &sigs, NULL);

  pid = Fork();
  if (pid == 0) {
    Signal(SIGINT, ctl_c);
    Sigemptyset(&sigs);
    
    while (count < 3) {
      Sigsuspend(&sigs);
    }

    return 0;
  }

  while (1) {
    kill(pid, SIGINT);
    if (Waitpid(pid, &status, WNOHANG) != 0)
      break;
  }

  return 0;
}
